#include "DiffBasic.h"

#include <NTL/ZZ.h>
#include <dtl/dtl.hpp>

using namespace std;

typedef char elem;
typedef std::string sequence;

DiffBasic::DiffBasic(int idx, int outStringLen, string inStr) {
    index = idx;
    outStringLength = outStringLen;
    inString = inStr;
}

vector<DiffBasic> DiffBasic::generateDiffs(string out, string in)
{
    vector<DiffBasic> allDiffs;
    
    //string a = "ertem esiner alptekin kupcu oznur ozkasap adilet kachkeev";
    //string b = "ertem esiner alp ozantekin kupcu oznur ozkasap adiletkachkee vvv";
    //string b = "ertem esiner1alptekin kupcu oznur ozkasap adilet kachkeev";
    
    sequence A(out); sequence B(in);
    dtl::Diff<elem, sequence > d(A, B);
    d.compose();             // construct an edit distance and LCS and SES
    d.composeUnifiedHunks(); // construct a difference as Unified Format with SES.
    stringstream oss; string mystr;
    d.printUnifiedFormat< stringstream >(oss);  // print a difference as Unified Format.
    mystr=oss.str();
    
    //	cout<<"google:"<< mystr <<endl;
    
    //	cout<<"What is that str:"<<mystr<<endl;
    //	cout<<"endd:"<<endl;
    std::istringstream is(mystr);
    //is >> std::noskipws;
    string line;
    char x;
    int index;
    is >> line;
    
    //Generation of in and out Strings
    while(!is.eof()){
        //Parse starting index
        is >> line;
        std::istringstream isIndex(line);
        isIndex>>x;
        isIndex>>index;
        //END Parse starting index
        is >> line;
        is >> line;
        
        
        is >> line;
        //Generate in and out Strings out of inputs
        string inString = "", outString="";
        while (1) {
            if(is.eof())
                break;
            
            
            if(line.compare("@@") == 0)
                break;
            
            std::istringstream isLine(line);
            //isLine >> std::noskipws>>x;
            //	isLine >> x;
            isLine.get(x);
            if(line.size() == 1 && x!='-' && x!='+'){
                outString += x;
                inString += x;
            }else if(x == '-')
            {
                if(line.size() != 1){
                    isLine >> x;
                    outString += x;
                }else{
                    outString +=' ';
                }
            }else if(x == '+')
            {
                
                if(line.size() != 1){
                    isLine >> std::noskipws >> x;
                    inString += x;
                }else{
                    inString+=' ';
                }
            }
            is >> line;
        }
        /*cout<<"index:"<< index << endl;
         cout <<"inString :"<< inString << endl;
         cout <<"outString:"<< outString << endl;
         cout<<"--"<<endl;*/
        //END Generate in and out Strings out of inputs
        
        //Trim Front
        int minSize = inString.size();
        if(outString.size() < minSize)
            minSize = outString.size();
        for(int i = 0; i < minSize; i++){
            // cout<<i<<" "<<inString[i]<<" "<<outString[i]<<endl;
            if(inString[i] == outString[i])
            {
                inString = inString.substr ( 1 );
                outString = outString.substr ( 1 );
                index++;
                i--;
            }else break;
        }
        //END Trim Front
        
        /*cout<<"index:"<< index << endl;
         cout <<"inString :"<< inString << endl;
         cout <<"outString:"<< outString << endl;
         cout<<"--"<<endl;*/
        
        //Trim Back
        minSize = inString.size();
        //	cout<<"size of outstr:"<<outString.size()<<endl;
        //cout <<"outString:"<<"/"<< outString <<"/"<< endl;
        if(outString.size() < minSize)
            minSize = outString.size();
        for(int i = minSize-1; i > -1; i--){
            if(inString[inString.size()-1-i] == outString[outString.size()-1-i])
            {
                inString = inString.substr ( 0,inString.size() - 1 );
                outString = outString.substr ( 0,outString.size() - 1 );
                //index++;
            }
        }
        //END Trim Back
        
        DiffBasic diff(index, outString.size(), inString);
        
        
        //	if(!is.eof()){
        
        allDiffs.push_back(diff);
        
        //	}else{
        //	cout<<"last diff in diff basic:"<<endl;
        //		diff.print();
        //	}
        /*
         cout<<"index      : "<< index << endl;
         cout <<"inString  : "<<"/"<< inString <<"/"<< endl;
         cout <<"outString : "<<"/"<< outString <<"/"<< endl;
         //cout <<"outStringwithspace:"<<"/ /"<< endl;
         cout<<"--"<<endl;
         cout << "END UPDATE" <<endl;
         */
        
    }
    //END Generation of in and out Strings
    return allDiffs;
}


void DiffBasic::print()
{
    cout<<"index      : "<< index << endl;
    cout <<"outStringLength : "<< outStringLength << endl;
    cout <<"inString  : "<<"|"<< inString <<"|"<< endl;
    
}

int DiffBasic::getIndex() { return index; }
int DiffBasic::getOutLength() { return outStringLength; }
string DiffBasic::getInString() { return inString; }
