#ifndef _DiffBasic_H_
#define _DiffBasic_H_

#include <NTL/ZZ.h>
#include <dtl/dtl.hpp>

/*------------------------------------------------------------------------
 * Program:   	DiffBasic
 *
 * Purpose:   	This class is basically an adapter to GoogleDiffMatchPatch algorithm to be turned into a format that we wish,
 *				So that which any diff algorithm, on the format of DiffBasic, our system will do her job.
 *
 *
 * Note:      	Note that this is just an adapter class only using GoogleDiffMatchPatch now, I preassume that the algorithm
 *				that we use for this operation may change later
 *
 *------------------------------------------------------------------------
 */

typedef char elem;
typedef std::string sequence;

class DiffBasic {
    
public:
    
    DiffBasic(int idx, int outStringLen, string inStr);
    static vector<DiffBasic> generateDiffs(string out, string in);
    void print();
    int getIndex();
    int getOutLength();
    string getInString();
    
private:
    
    int index;				// The index where the change starts
    int outStringLength;	// The string which leaves
    string inString;		// The string which comes
    
};

#endif /*_DiffBasic_H_*/
