#ifndef _PacketBase_H_
#define _PacketBase_H_

#include <vector>
#include <NTL/ZZ.h>
#include <cstdlib>
#include <DPDPCONST.h>
#include <string.h>
#include <Serialize.h>
#include <boost/serialization/vector.hpp>
#include <DiffSkipList.h>

/*------------------------------------------------------------------------
 * Program:   	PacketBase
 *
 * Purpose:   	This class is the base class for packets which will go through network
 *
 *
 * Note:      	TYPE includes all type of packages including test ones such as INSERT REMOVE MODIFY PROOF UPDATEPROOF,
 *				They are not needed in the actual protocol
 *
 *------------------------------------------------------------------------
 */

class PacketBase {
	
public:
	enum TYPE { INIT = 1, REINIT, CHALLENGE, TRANSMISSION, REMOVE, INSERT, MODIFY, INFO, UPDATEPROOF, PROOF, REWRITEPROOF, COMMIT, COMMITPROOF};
	
	PacketBase(TYPE t) { type = t; }
	PacketBase() {}
	~PacketBase() {}
	void print() {}
	
	TYPE getType() { return type; }
	
	friend class boost::serialization::access;
	template <class Archive> 
	void serialize(Archive& ar, const unsigned int ver) {
		ar  	& auto_nvp(type);
	}
	
private:

	TYPE type;
    
};

#endif /*_PacketBase_H_*/
